#! /bin/jsh
#
# Copyright 2013-2014 Yuichiro Moriguchi
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
cat << EOF
	private int ${4}_Step($2 __c__)
	{
		switch(__this__.STATE)
		{
EOF
print_states $1 $5
cat << EOF
		}
		return 0;
	}

	private bool ${4}_Accepted()
	{
EOF
print_accepts $1
echo '	}'
echo

if [ -z "$3" ]
then
  echo "	private object ${4}_Gettoken(System.Text.StringBuilder __b__)"
  echo '	{'
  echo '		string __r__ = __b__.ToString();'
else
  echo "	private object ${4}_Gettoken($CTYPE[] __b__)"
  echo "	{"
  echo "		$CTYPE[] __r__ = __b__;"
fi
echo
echo '		switch(__this__.STATE)'
echo '		{'
print_token $1
echo '		default:  return null;'
echo '		}'
echo '	}'
echo

echo "	private bool ${4}_Isdead()"
echo '	{'
print_nfadead $1
echo '	}'
